# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.device_id_search import DeviceIdSearch


class AccountDeviceListFilter(object):

    """Implementation of the 'AccountDeviceListFilter' model.

    Filter for a list of devices.

    Attributes:
        device_identifier_filters (list of DeviceIdSearch): Specify the kind
            of the device identifier, the type of match, and the string that
            you want to match.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "device_identifier_filters": 'deviceIdentifierFilters'
    }

    _optionals = [
        'device_identifier_filters',
    ]

    def __init__(self,
                 device_identifier_filters=APIHelper.SKIP):
        """Constructor for the AccountDeviceListFilter class"""

        # Initialize members of the class
        if device_identifier_filters is not APIHelper.SKIP:
            self.device_identifier_filters = device_identifier_filters 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        device_identifier_filters = None
        if dictionary.get('deviceIdentifierFilters') is not None:
            device_identifier_filters = [DeviceIdSearch.from_dictionary(x) for x in dictionary.get('deviceIdentifierFilters')]
        else:
            device_identifier_filters = APIHelper.SKIP
        # Return an object of this model
        return cls(device_identifier_filters)
