# -*- coding: utf-8 -*-

"""
verizon

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from verizon.api_helper import APIHelper
from verizon.models.account_device_list import AccountDeviceList
from verizon.models.custom_fields import CustomFields


class AddDevicesRequest(object):

    """Implementation of the 'AddDevicesRequest' model.

    Request to add the devices.

    Attributes:
        account_name (string): The billing account to which the devices are
            added.
        custom_fields (list of CustomFields): The names and values for any
            custom fields that you want set for the devices as they are added
            to the account.
        devices_to_add (list of AccountDeviceList): The devices that you want
            to add.
        group_name (string): The name of a device group to add the devices to.
            They are added to the default device group if you don't include
            this parameter.
        sku_number (string): The Stock Keeping Unit (SKU) number of a 4G
            device type with an embedded SIM.
        state (string): The initial service state for the devices. The only
            valid state is “Preactive.”

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_name": 'accountName',
        "custom_fields": 'customFields',
        "devices_to_add": 'devicesToAdd',
        "group_name": 'groupName',
        "sku_number": 'skuNumber',
        "state": 'state'
    }

    _optionals = [
        'account_name',
        'custom_fields',
        'devices_to_add',
        'group_name',
        'sku_number',
        'state',
    ]

    def __init__(self,
                 account_name=APIHelper.SKIP,
                 custom_fields=APIHelper.SKIP,
                 devices_to_add=APIHelper.SKIP,
                 group_name=APIHelper.SKIP,
                 sku_number=APIHelper.SKIP,
                 state=APIHelper.SKIP):
        """Constructor for the AddDevicesRequest class"""

        # Initialize members of the class
        if account_name is not APIHelper.SKIP:
            self.account_name = account_name 
        if custom_fields is not APIHelper.SKIP:
            self.custom_fields = custom_fields 
        if devices_to_add is not APIHelper.SKIP:
            self.devices_to_add = devices_to_add 
        if group_name is not APIHelper.SKIP:
            self.group_name = group_name 
        if sku_number is not APIHelper.SKIP:
            self.sku_number = sku_number 
        if state is not APIHelper.SKIP:
            self.state = state 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        account_name = dictionary.get("accountName") if dictionary.get("accountName") else APIHelper.SKIP
        custom_fields = None
        if dictionary.get('customFields') is not None:
            custom_fields = [CustomFields.from_dictionary(x) for x in dictionary.get('customFields')]
        else:
            custom_fields = APIHelper.SKIP
        devices_to_add = None
        if dictionary.get('devicesToAdd') is not None:
            devices_to_add = [AccountDeviceList.from_dictionary(x) for x in dictionary.get('devicesToAdd')]
        else:
            devices_to_add = APIHelper.SKIP
        group_name = dictionary.get("groupName") if dictionary.get("groupName") else APIHelper.SKIP
        sku_number = dictionary.get("skuNumber") if dictionary.get("skuNumber") else APIHelper.SKIP
        state = dictionary.get("state") if dictionary.get("state") else APIHelper.SKIP
        # Return an object of this model
        return cls(account_name,
                   custom_fields,
                   devices_to_add,
                   group_name,
                   sku_number,
                   state)
